From ac7227a4444de2ba862f2bc1befe4dbee7076803 Mon Sep 17 00:00:00 2001
From: Min Chen <chenmin@kuaishou.com>
Date: Sat, 28 Jul 2018 12:33:36 +0800
Subject: [PATCH] improve pow(x,2)

---
 source/encoder/encoder.cpp | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

diff --git a/source/encoder/encoder.cpp b/source/encoder/encoder.cpp
index ea04614..7c2dcdf 100644
--- a/source/encoder/encoder.cpp
+++ b/source/encoder/encoder.cpp
@@ -4078,8 +4078,10 @@ int Encoder::getCUIndex(cuLocation* cuLoc, uint32_t* count, int bytes, int flag)
         else
         {
             /* Number of 4x4 blocks in out of bound region */
-            int outOfBound = m_param->maxCUSize / 2;
-            uint32_t sum = (uint32_t)pow((outOfBound >> 2), 2);
+            //int outOfBound = m_param->maxCUSize / 2;
+            //uint32_t sum = (uint32_t)pow((outOfBound >> 2), 2);
+            uint32_t sum = 1 << (2 * (m_param->maxLog2CUSize - 3));
+            X265_CHECK(sum == ((m_param->maxCUSize >> 3) * (m_param->maxCUSize >> 3)), "pow(outOfBound,2) check failed");
             index += sum;
         }
         cuLoc->switchCondition += m_param->num4x4Partitions;
@@ -4105,8 +4107,10 @@ int Encoder::getCUIndex(cuLocation* cuLoc, uint32_t* count, int bytes, int flag)
                 index += 2;
             else
             {
-                int outOfBound = m_param->maxCUSize / 2;
-                uint32_t sum = (uint32_t)(2 * pow((abs(outOfBound) >> 2), 2));
+                //int outOfBound = m_param->maxCUSize / 2;
+                //uint32_t sum = (uint32_t)(2 * pow((abs(outOfBound) >> 2), 2));
+                uint32_t sum = 2 << (2 * (m_param->maxLog2CUSize - 3));
+                X265_CHECK(sum == (2 * (m_param->maxCUSize >> 3) * (m_param->maxCUSize >> 3)), "pow(outOfBound,2) check failed");
                 index += sum;
             }
             *count = cuLoc->evenRowIndex;
-- 
2.9.0.windows.1

